SybaseAnywhereMaxValueIncrementer (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.jdbc.support.incrementer

## Class SybaseAnywhereMaxValueIncrementer

- java.lang.Object
- - org.springframework.jdbc.support.incrementer.AbstractDataFieldMaxValueIncrementer
  - - org.springframework.jdbc.support.incrementer.AbstractColumnMaxValueIncrementer
    - - org.springframework.jdbc.support.incrementer.SybaseMaxValueIncrementer
      - - org.springframework.jdbc.support.incrementer.SybaseAnywhereMaxValueIncrementer

- All Implemented Interfaces:
    InitializingBean, DataFieldMaxValueIncrementer

      public class SybaseAnywhereMaxValueIncrementer
      extends SybaseMaxValueIncrementer

  `DataFieldMaxValueIncrementer` that increments the maximum value of a given Sybase SQL Anywhere table with the equivalent of an auto-increment column. Note: If you use this class, your table key column should NOT be defined as an IDENTITY column, as the sequence table does the job.

  This class is intended to be used with Sybase Anywhere.

  The sequence is kept in a table. There should be one sequence table per table that needs an auto-generated key.

  Example:

       create table tab (id int not null primary key, text varchar(100))
       create table tab_sequence (id bigint identity)
       insert into tab_sequence values(DEFAULT)

  If "cacheSize" is set, the intermediate values are served without querying the database. If the server or your application is stopped or crashes or a transaction is rolled back, the unused values will never be served. The maximum hole size in numbering is consequently the value of cacheSize. HINT: Since Sybase Anywhere supports the JDBC 3.0 `getGeneratedKeys` method, it is recommended to use IDENTITY columns directly in the tables and then using a `SimpleJdbcInsert` or utilizing a `KeyHolder` when calling the with the `update(PreparedStatementCreator psc, KeyHolder generatedKeyHolder)` method of the `JdbcTemplate`.

  Thanks to Tarald Saxi Stormark for the suggestion!

  Since:
    3.0.5
  Author:
    Thomas Risberg

- - ### Field Summary

    - ### Fields inherited from class org.springframework.jdbc.support.incrementer.AbstractDataFieldMaxValueIncrementer

      `paddingLength`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SybaseAnywhereMaxValueIncrementer()` Default constructor for bean property style usage.
    `SybaseAnywhereMaxValueIncrementer(DataSource dataSource, String incrementerName, String columnName)` Convenience constructor.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected String` | `getIncrementStatement()` Statement to use to increment the "sequence" value.

    - ### Methods inherited from class org.springframework.jdbc.support.incrementer.SybaseMaxValueIncrementer

      `getNextKey`

    - ### Methods inherited from class org.springframework.jdbc.support.incrementer.AbstractColumnMaxValueIncrementer

      `afterPropertiesSet, getCacheSize, getColumnName, setCacheSize, setColumnName`

    - ### Methods inherited from class org.springframework.jdbc.support.incrementer.AbstractDataFieldMaxValueIncrementer

      `getDataSource, getIncrementerName, getPaddingLength, nextIntValue, nextLongValue, nextStringValue, setDataSource, setIncrementerName, setPaddingLength`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SybaseAnywhereMaxValueIncrementer

          public SybaseAnywhereMaxValueIncrementer()

      Default constructor for bean property style usage.
      See Also:
        `AbstractDataFieldMaxValueIncrementer.setDataSource(javax.sql.DataSource)`, `AbstractDataFieldMaxValueIncrementer.setIncrementerName(java.lang.String)`, `AbstractColumnMaxValueIncrementer.setColumnName(java.lang.String)`

    - #### SybaseAnywhereMaxValueIncrementer

          public SybaseAnywhereMaxValueIncrementer(DataSource dataSource,
                                           String incrementerName,
                                           String columnName)

      Convenience constructor.
      Parameters:
        `dataSource` - the DataSource to use
        `incrementerName` - the name of the sequence/table to use
        `columnName` - the name of the column in the sequence table to use

  - ### Method Detail

    - #### getIncrementStatement

          protected String getIncrementStatement()

      Description copied from class: `SybaseMaxValueIncrementer`
      Statement to use to increment the "sequence" value. Can be overridden by sub-classes.
      Overrides:
        `getIncrementStatement` in class `SybaseMaxValueIncrementer`
      Returns:
        The SQL statement to use